enyo.kind(
{
	name: "ContactsDb",
	kind: "Component",
	
	components: [
		{
			name: "dbsFindContacts",
			kind: "DbService",
			dbKind: "com.palm.person:1",
			method: "find",
			onSuccess: "generalCallback",
			subscribe: false
		}
	],
	
	
	create: function ()
	{
		this.inherited(arguments);
		
		if (enyo.application.ContactsDb === undefined)
		{
			enyo.application.ContactsDb = this;
		}
		
	},
	
	
    getContacts: function (callback)
    {
    	var q =  {};
    	this.loadPaginatedQuery (q, callback);
    },
	
	
	//CALL THIS ONCE at the start
	loadContacts : function(onlyBirthdays,callback)
	{
		this.getContacts(
			function(objResponse){
				
				var recs = [];
				for (var i=0;i<objResponse.results.length;i++){
					
					
					var entry = objResponse.results[i];
					
					
					if (entry.names[0] != null)
					{
						if ((onlyBirthdays && entry.birthday) || !onlyBirthdays)
						{
							recs.push({
								'familyName': entry.names[0].familyName ? entry.names[0].familyName : "",
								'givenName': entry.names[0].givenName ? entry.names[0].givenName: "",
								'birthday': entry.birthday ? entry.birthday: "",
								'squarePhoto': entry.photos.squarePhotoPath ? entry.photos.squarePhotoPath : ""
							});
						}
					}
				}
				
				
				enyo.application.ContactsList = recs;
				callback(enyo.application.ContactsList);
			}.bind(this)
		);
	},
	
	
	
	

	
	/*private*/
	/*paginated queries*/
	loadPaginatedQuery : function(query, callback)
	{
		console.log('----ContactsDb: loading contacts db via paginated query');
		
		//here we will store data from all pages
		var results = [];
		
		//this will happen on find service (dbsFindContacts) callback
		
		this.getContactsCallback =
			function(response){
				//console.log('----ContactsDb: next page address: '+Object.toJSON(response));
				if (response.returnValue){
					
					//add results to results array
					results = results.concat(response.results);
					
					
					//if there is a next page
					if (response.next != null){
						//load next page
						this.loadOnePageForQuery(query, response.next);			
					}
				
					//we have one page (or loaded last one)
					else{
						console.log('----ContactsDb: Paginated Query response length: '+results.length);
						callback ({'returnValue':true, 'results':results});		
					}
				}		
			}.bind(this)
	
		//load first page
		this.loadOnePageForQuery(query, null);
	},
	
	
	loadOnePageForQuery : function(query, page)
	{
		var params = {
			watch: false, 
			query: query,
			subscribe: false
		};
		
		if (page != null){
			params.query.page = page;
		}
		
		this.$.dbsFindContacts.call(params, {});		
	},
	
	
	
	generalCallback : function (inSender,inResponse)
	{
		this.getContactsCallback(inResponse);
	}
    
     
});